
// DrZ80 - Header File

// All code (c) Copyright 2004 Reesy, All rights reserved.
// DrZ80 is free for non-commercial use.

// For commercial use, separate licencing terms must be obtained.

#ifdef __cplusplus
extern "C" {
#endif

extern int DrZ80Ver; // Version number of library

struct DrZ80
{ 
  unsigned int Z80A;            //0x00
  unsigned int Z80F;            //0x04
  unsigned int Z80BC;           //0x08
  unsigned int Z80DE;           //0x0C
  unsigned int Z80HL;           //0x10
  unsigned int Z80PC;           //0x14
  unsigned int Z80PC_BASE;      //0x18
  unsigned int Z80SP;           //0x1C
  unsigned int Z80SP_BASE;      //0x20
  unsigned int Z80IX;           //0x24
  unsigned int Z80IY;           //0x28
  unsigned int Z80I;            //0x2C
  unsigned int Z80A2;           //0x30
  unsigned int Z80F2;           //0x34
  unsigned int Z80BC2;          //0x38
  unsigned int Z80DE2;          //0x3C
  unsigned int Z80HL2;          //0x40    
  unsigned char Z80_IRQ;        //0x44   
  unsigned char Z80IF;          //0x48
  unsigned char Z80IM;          //0x4C
  unsigned char spare;          //0x4C
  unsigned int z80irqvector;    //0x38
  void (*z80_irq_callback )(void);
  void (*z80_write8 )(unsigned char d,unsigned short a); 
  void (*z80_write16 )(unsigned short d,unsigned short a); 
  unsigned char (*z80_in)(unsigned char p);
  void (*z80_out )(unsigned char p,unsigned char d);
  unsigned char (*z80_read8)(unsigned short a);
  unsigned short (*z80_read16)(unsigned short a);
  unsigned int (*z80_rebaseSP)(unsigned short new_sp);
  unsigned int (*z80_rebasePC)(unsigned short new_pc);
};

extern void DrZ80Run(struct DrZ80 *pcy,unsigned int cyc);

#ifdef __cplusplus
} // End of extern "C"
#endif
